import java.io.*;
import java.util.*;

public class extreme_mb {
    private static boolean yesNo(String line) {
        return line.substring(line.lastIndexOf(' ') + 1).equals("Yes");
    }

    private static int power(int a, int x) {
        int rv = 1;
        for (int i = 0; i < x; ++i) {
            rv *= a;
        }
        return rv;
    }

    private static int[] dx = {-1, 0, 1, 0};
    private static int[] dy = {0, 1, 0, -1};

    private static final int MINMAX_MIN = 1;
    private static final int MINMAX_MAX = 19;

    private static boolean hasMultipleMaxima(int[][] target) {
        int countMaxima = 0;
        for (int x = MINMAX_MIN; x <= MINMAX_MAX; ++x) {
            for (int y = MINMAX_MIN; y <= MINMAX_MAX; ++y) {
                int cv = target[x][y];
                boolean isMax = true;
                for (int d = 0; d < 4; ++d) {
                    int nx = x + dx[d];
                    int ny = y + dy[d];
                    if (nx >= 0 && ny >= 0 && nx <= 20 && ny <= 20) {
                        if (target[nx][ny] >= cv) {
                            isMax = false;
                            break;
                        }
                    }
                }
                if (isMax) {
                    ++countMaxima;
                    if (countMaxima > 1) {
                        return true;
                    }
                }
            }
        }
        return false;
    }

    private static boolean hasMultipleMinima(int[][] target) {
        int countMinima = 0;
        for (int x = MINMAX_MIN; x <= MINMAX_MAX; ++x) {
            for (int y = MINMAX_MIN; y <= MINMAX_MAX; ++y) {
                int cv = target[x][y];
                boolean isMin = true;
                for (int d = 0; d < 4; ++d) {
                    int nx = x + dx[d];
                    int ny = y + dy[d];
                    if (nx >= 0 && ny >= 0 && nx <= 20 && ny <= 20) {
                        if (target[nx][ny] <= cv) {
                            isMin = false;
                            break;
                        }
                    }
                }
                if (isMin) {
                    ++countMinima;
                    if (countMinima > 1) {
                        return true;
                    }
                }
            }
        }
        return false;
    }

    private static boolean hasPlateaus(int[][] target) {
        for (int x = 0; x <= 20; ++x) {
            for (int y = 0; y <= 20; ++y) {
                int cv = target[x][y];
                if (x < 20 && cv == target[x + 1][y] || y < 20 && cv == target[x][y + 1]) {
                    return true;
                }
            }
        }
        return false;
    }

    private static class Stack {
        int[] values;
        int size;

        Stack(int size) {
            this.values = new int[size];
            this.size = 0;
        }

        void clear() {
            size = 0;
        }

        void push(int value) {
            values[size++] = value;
        }

        int pop() {
            return values[--size];
        }
    }

    private static abstract class Operation {
        abstract boolean act(Stack stack, int x, int y);
    }

    private static abstract class BinaryOperation extends Operation {
        abstract long evaluate(long a, long b);
        boolean act(Stack stack, int x, int y) {
            long b = stack.pop();
            long a = stack.pop();
            long result = evaluate(a, b);
            if (result < Integer.MIN_VALUE || result > Integer.MAX_VALUE) {
                return false;
            }
            stack.push((int) (result));
            return true;
        }
    }

    private static final Operation opX = new Operation() {
        boolean act(Stack stack, int x, int y) { stack.push(x); return true; };
        public String toString() { return "x"; }
    };
    private static final Operation opY = new Operation() {
        boolean act(Stack stack, int x, int y) { stack.push(y); return true; };
        public String toString() { return "y"; }
    };
    private static final Operation add = new BinaryOperation() {
        long evaluate(long a, long b) { return a + b; }
        public String toString() { return "+"; }
    };
    private static final Operation sub = new BinaryOperation() {
        long evaluate(long a, long b) { return a - b; }
        public String toString() { return "-"; }
    };
    private static final Operation mul = new BinaryOperation() {
        long evaluate(long a, long b) { return a * b; }
        public String toString() { return "*"; }
    };
    private static final Operation pow = new BinaryOperation() {
        long evaluate(long a, long b) {
            long result = 1;
            long pow = a;
            if (b < 0) {
                return Long.MAX_VALUE;
            }
            while (b > 0) {
                if (pow < Integer.MIN_VALUE || pow > Integer.MAX_VALUE) {
                    return pow;
                }
                if ((b & 1) == 1) {
                    result *= pow;
                    if (result < Integer.MIN_VALUE || result > Integer.MAX_VALUE) {
                        return result;
                    }
                }
                pow *= pow;
                b >>>= 1;
            }
            return result;
        }
        public String toString() { return "^"; }
    };
    private static final Operation[] constants = new Operation[19];
    static {
        for (int i = -9; i <= 9; ++i) {
            final int ii = i;
            constants[i + 9] = new Operation() {
                boolean act(Stack stack, int x, int y) {
                    stack.push(ii);
                    return true;
                }
                public String toString() { return String.valueOf(ii); }
            };
        }
    }

    private static boolean tabulate(Operation[] operations, int nOperations, Stack stack, int[][] target) {
        for (int x = -10; x <= 10; ++x) {
            for (int y = -10; y <= 10; ++y) {
                stack.clear();
                for (int i = 0; i < nOperations; ++i) {
                    if (!operations[i].act(stack, x, y)) {
                        return false;
                    }
                }
                if (stack.size != 1) {
                    return false;
                }
                target[x + 10][y + 10] = stack.pop();
            }
        }
        return true;
    }

    private static String attemptRandomOps(boolean maxima, boolean minima, boolean plateaus) {
        int maxOperations = 17;
        int[][] target = new int[21][21];
        Stack stack = new Stack(maxOperations);
        Operation[] operations = new Operation[maxOperations];
        Random random = new Random(73242341232L);
        int alive = 0, total = 0;
        while (true) {
            int nOperations = Math.min(maxOperations, 1 + 10 * ((32 - Integer.numberOfLeadingZeros(alive)) / 3));
            for (int i = 0, sz = 0, remaining = nOperations; i < nOperations; ++i, --remaining) {
                // N, x, y, +, -, *, ^
                int rngMin = remaining == sz ? 3 : 0;
                int rngMax = sz >= 2 ? 7 : 3;
                int index = rngMin + random.nextInt(rngMax - rngMin);
                switch (index) {
                    case 0: operations[i] = constants[random.nextInt(constants.length)]; ++sz; break;
                    case 1: operations[i] = opX; ++sz; break;
                    case 2: operations[i] = opY; ++sz; break;
                    case 3: operations[i] = add; --sz; break;
                    case 4: operations[i] = sub; --sz; break;
                    case 5: operations[i] = mul; --sz; break;
                    case 6: operations[i] = pow; --sz; break;
                }
            }
            if (tabulate(operations, nOperations, stack, target)) {
                if (maxima == hasMultipleMaxima(target) && minima == hasMultipleMinima(target) && plateaus == hasPlateaus(target)) {
                    StringBuilder sb = new StringBuilder();
                    for (int i = 0; i < nOperations; ++i) {
                        if (i > 0) {
                            sb.append(" ");
                        }
                        sb.append(operations[i]);
                    }
                    return sb.toString();
                }
                ++alive;
            }
            if (++total % 10000 == 0) {
                System.err.println("Total: " + total + ", alive = " + alive);
            }
        }
    }

    public static void main(String[] args) throws IOException {
        try (BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
             PrintWriter out = new PrintWriter(System.out)) {
            boolean maxima = yesNo(in.readLine());
            boolean minima = yesNo(in.readLine());
            boolean plateaus = yesNo(in.readLine());
            out.println(attemptRandomOps(maxima, minima, plateaus));
        }
    }
}
