import java.io.*;
import java.util.*;

public class extreme_mb_tl_singleopt {
    private static boolean yesNo(String line) {
        return line.substring(line.lastIndexOf(' ') + 1).equals("Yes");
    }

    private static int power(int a, int x) {
        int rv = 1;
        for (int i = 0; i < x; ++i) {
            rv *= a;
        }
        return rv;
    }

    private static void tabulate(int x1, int y1, int p1, int x2, int y2, int p2, int[][] target) {
        for (int x = -10; x <= 10; ++x) {
            for (int y = -10; y <= 10; ++y) {
                target[x + 10][y + 10] = p1 * power(x, x1) * power(y, y1) + p2 * power(x, x2) * power(y, y2);
            }
        }
    }

    private static int[] dx = {-1, 0, 1, 0};
    private static int[] dy = {0, 1, 0, -1};

    private static final int MINMAX_MIN = 0;
    private static final int MINMAX_MAX = 20;

    private static boolean hasMultipleMaxima(int[][] target) {
        for (int x = MINMAX_MIN; x <= MINMAX_MAX; ++x) {
            for (int y = MINMAX_MIN; y <= MINMAX_MAX; ++y) {
                int cv = target[x][y];
                boolean isMax = true;
                for (int d = 0; d < 4; ++d) {
                    int nx = x + dx[d];
                    int ny = y + dy[d];
                    if (nx >= 0 && ny >= 0 && nx <= 20 && ny <= 20) {
                        if (target[nx][ny] >= cv) {
                            isMax = false;
                            break;
                        }
                    }
                }
                if (isMax) {
                    return true;
                }
            }
        }
        return false;
    }

    private static boolean hasMultipleMinima(int[][] target) {
        for (int x = MINMAX_MIN; x <= MINMAX_MAX; ++x) {
            for (int y = MINMAX_MIN; y <= MINMAX_MAX; ++y) {
                int cv = target[x][y];
                boolean isMin = true;
                for (int d = 0; d < 4; ++d) {
                    int nx = x + dx[d];
                    int ny = y + dy[d];
                    if (nx >= 0 && ny >= 0 && nx <= 20 && ny <= 20) {
                        if (target[nx][ny] <= cv) {
                            isMin = false;
                            break;
                        }
                    }
                }
                if (isMin) {
                    return true;
                }
            }
        }
        return false;
    }

    private static boolean hasPlateaus(int[][] target) {
        for (int x = 0; x <= 20; ++x) {
            for (int y = 0; y <= 20; ++y) {
                int cv = target[x][y];
                if (x < 20 && cv == target[x + 1][y] || y < 20 && cv == target[x][y + 1]) {
                    return true;
                }
            }
        }
        return false;
    }

    private static String attemptTwoMonomials(boolean maxima, boolean minima, boolean plateaus) {
        int[][] target = new int[21][21];

        for (int x1 = 0; x1 <= 4; ++x1) {
            for (int y1 = 0; y1 <= 4; ++y1) {
                for (int p1 = -9; p1 <= 9; ++p1) {
                    for (int x2 = 0; x2 <= 4; ++x2) {
                        for (int y2 = 0; y2 <= 4; ++y2) {
                            for (int p2 = -9; p2 <= 9; ++p2) {
                                tabulate(x1, y1, p1, x2, y2, p2, target);
                                if (maxima == hasMultipleMaxima(target) && minima == hasMultipleMinima(target) && plateaus == hasPlateaus(target)) {
                                    return "x " + x1 + " ^ y " + y1 + " ^ " + p1 + " * * x " + x2 + " ^ y " + y2 + " ^ " + p2 + " * * +";
                                }
                            }
                        }
                    }
                }
            }
        }
        return "No solution";
    }

    public static void main(String[] args) throws IOException {
        try (BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
             PrintWriter out = new PrintWriter(System.out)) {
            boolean maxima = yesNo(in.readLine());
            boolean minima = yesNo(in.readLine());
            boolean plateaus = yesNo(in.readLine());
            out.println(attemptTwoMonomials(maxima, minima, plateaus));
        }
    }
}
