#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int n, m;
vector<int> a;

inline int readAndCheckAnswer(InStream& in) {
    int ans = in.readInt();
    int zone = in.readInt();
    if (ans < 1 || ans > n) {
      in.quitf(_wa, "invalid answer: %d, must be in [%d, %d]", ans, 1, n);
    }
    if (zone < 0 || zone >= m) {
      in.quitf(_wa, "invalid time zone: %d, must be in [%d; %d]", zone, 0, m - 1);
    }
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
      b[i] = (a[i] + zone) / m;
    }
    int beg = 0;
    int res = 0;
    while (beg < n) {
      int end = beg;
      while (end + 1 < n && b[end + 1] - b[end] <= 1) {
        ++end;
      }
      res = max(res, b[end] - b[beg] + 1);
      beg = end + 1;
    }
    if (res != ans) {
      in.quitf(_wa, "incorrect answer for time zone %d: declared %d, actual %d", zone, ans, res);
    }
    return res;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    int tt;
    tt = inf.readInt();
    for (int qq = 1; qq <= tt; qq++) {
      setTestCase(qq);
      n = inf.readInt();
      m = inf.readInt();
      a.resize(n);
      for (int i = 0; i < n; i++) {
        a[i] = inf.readInt();
      }

      int ja = readAndCheckAnswer(ans);
      int pa = readAndCheckAnswer(ouf);

      if(ja > pa)
          quitf(_wa, "jury has value %d but participant has value %d", ja, pa);
      if(ja < pa)
          quitf(_fail, "jury has value %d but participant has value %d", ja, pa);
    }

    quitf(_ok, "ok, %d test cases", tt);
}
