#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <sstream>
#include <list>
#include <queue>
#include <deque>
#include <stack>
#include <cstdlib>
#include <cstdio>
#include <iterator>
#include <functional>
#include <bitset>

#ifdef LOCAL
#define eprintf(...) fprintf(stderr,__VA_ARGS__)
clock_t __my_start_clock = clock();
#else
#define eprintf(...)
#endif

#define TIMESTAMP(x) eprintf("["#x"] Time : %.3lf s.\n", (clock() - __my_start_clock)*1.0/CLOCKS_PER_SEC)
#define TIMESTAMPf(x,...) eprintf("[" x "] Time : %.3lf s.\n", __VA_ARGS__, (clock() - __my_start_clock)*1.0/CLOCKS_PER_SEC)

using namespace std;

#ifdef LOCAL
static struct __timestamper {
  string what;
  __timestamper(const char* what) : what(what){};
  __timestamper(const string& what) : what(what){};
  ~__timestamper(){
    TIMESTAMPf("%s", what.data());
	}
} __TIMESTAMPER("end");
#else 
struct __timestamper {};
#endif

typedef long long ll;
typedef long double ld;

void solve() {
  int n, m;
  scanf("%d%d", &n, &m);
  vector<int> a(n);
  for (int &x : a) scanf("%d", &x);
  sort(a.begin(), a.end(), [&](int x, int y) { return x % m > y % m; });
  map<int, int> in_day;
  map<int, int> ranges;
  multiset<int> lengths;

  auto remove_range = [&](int from) {
    auto it = ranges.find(from);
    if (it != ranges.end()) {
      eprintf("remove [%d,%d)\n", from, it->second);
      auto lit = lengths.find(it->second - it->first);
      assert(lit != lengths.end());
      lengths.erase(lit);
      ranges.erase(it);
    }
  };

  auto add_range = [&](int from, int to) {
    remove_range(from);
    if (from != to) {
      eprintf("add [%d,%d)\n", from, to);
      ranges[from] = to;
      lengths.insert(to - from);
    }
  };

  auto add_to_day = [&](int x) {
    in_day[x]++;
    if (in_day[x] == 1) {
      int upto;
      if (ranges.find(x + 1) != ranges.end()) {
        upto = ranges[x + 1];
        remove_range(x + 1);
      } else {
        upto = x + 1;
      }
      auto it = ranges.lower_bound(x);
      int from = x;
      if (it != ranges.begin()) {
        --it;
        if (it->second == x) {
          from = it->first;
        }
      }
      add_range(from, upto);
    }
  };

  auto remove_from_day = [&](int x) {
    in_day[x]--;
    if (in_day[x] == 0) {
      in_day.erase(x);
      auto it = ranges.upper_bound(x);
      assert(it != ranges.begin());
      --it;
      assert(it->first <= x && x < it->second);
      add_range(x + 1, it->second);
      add_range(it->first, x);
    }
  };

  for (int i = 0; i < n; i++) {
    add_to_day(a[i] / m);
  }

  int ans = *lengths.rbegin();
  int anst = 0;
  for (int i = 0; i < n;) {
    int j = i;
    while (j < n && a[j] % m == a[i] % m) {
      add_to_day(a[j] / m + 1);
      remove_from_day(a[j] / m);
      j++;
    }
    int score = *lengths.rbegin();
    if (score > ans) {
      ans = score;
      anst = m - a[i] % m;
    }
    i = j;

  }
  printf("%d %d\n", ans, anst);
}

int main() {
#ifdef LOCAL
  freopen("d.in", "r", stdin);
  freopen("d.out", "w", stdout);
#endif

  int t;
  scanf("%d", &t);
  while (t-->0) solve();

  return 0;
}