import java.io.StringReader
import java.util.*
import kotlin.random.Random

private const val N = 1 shl 14
private const val EPSILON_INVERSE = 100
private val tests = """
imprecise_tests id n=4 > $
imprecise_tests random seed=1 > $
imprecise_tests random seed=2 > $
imprecise_tests id > $
"""

fun random(): List<Int> {
	val n = property("n", N)
	val a = (1..n).toList().shuffled(random)
	return a
}

fun id(): List<Int> {
	val n = property("n", N)
	return (1..n).toList()
}

private fun Boolean.toInt() = if (this) 1 else 0

private lateinit var random: Random
private lateinit var properties: Properties
private fun property(name: String, defaultValue: Int) = properties.getProperty(name)?.toInt() ?: defaultValue
private fun propertyDouble(name: String, defaultValue: Double) = properties.getProperty(name)?.toDouble() ?: defaultValue
private fun String.short() = if (this.length < 90) this else this.take(40) + "…" + this.takeLast(40)
fun main(args: Array<String>) = run(args)

private fun run(args: Array<String>) {
	if (args.isEmpty()) {
		tests.trimIndent().split("\n").forEach { run(it.split(" ").drop(1).dropLast(2).toTypedArray()) }
		return println(tests)
	}
	random = Random(56623930_9275692 + args.contentHashCode())
	properties = Properties().also { it.load(StringReader(args.drop(1).joinToString("\n"))) }
	@Suppress("UNCHECKED_CAST")
	val test = object {}.javaClass.enclosingClass.getMethod(args[0]).invoke(null) as List<Int>
	println(test.size)
	println(test.joinToString(" "))
}
