#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int n, m;
map<pair<int, int>, int> e;

pair<int, int> readAnswer(InStream &out) {
    int k = out.readInt(1, n - 1);
    vector<int> p(k + 1);
    for (int i = 0; i <= k; i++) p[i] = out.readInt(1, n);
    if (p[0] != 1) {
        out.quitf(_wa, "route must start at city 1");
    }
    if (p[k] != n) {
        out.quitf(_wa, "route must finish at city n (%d)", n);
    }
    int mn = INT_MAX;
    int mx = INT_MIN;
    for (int i = 0; i < k; i++) {
        pair<int, int> ee = {p[i], p[i + 1]};
        if (e.find(ee) == e.end()) {
            out.quitf(_wa, "no such edge");
        }
        int w = e[ee];
        mn = min(mn, w);
        mx = max(mx, w);
    }
    return {k, mn - mx};
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    m = inf.readInt();

    for (int i = 0; i < m; i++) {
        int x, y, c;
        x = inf.readInt();
        y = inf.readInt();
        c = inf.readInt();
        e[{x, y}] = c;
        e[{y, x}] = c;
    }
    auto pa = readAnswer(ouf);
    auto ja = readAnswer(ans);

    if (pa < ja) {
        quitf(_fail, "participant has better answer");
    } else if (pa > ja) {
        quitf(_wa, "jury has better answer");
    } else {
        quitf(_ok, "%d %d", ja.first, -ja.second);
    }
}