#include "testlib.h"
#include <cassert>
#include <functional>

using namespace std;

struct vertex {
	int white;
	int black;
};

struct test {
	vector<vertex> a;
};

test gen(int n, string op) {
	long long sumD = 2 * (n - 1) + rnd.next(2, 5) * (1LL << 32);
	vector<vertex> a(n);
	int w = 0;
	for (int i = 0; i < n; i++) {
		int d = rnd.next(1, (int) min<long long>(n - 1, sumD - (n - i - 1)));
		sumD -= d;
		if (op == "white") {
			a[i].white = d;
			a[i].black = 0;
		} else if (op == "black") {
			a[i].white = 0;
			a[i].black = d;
		} else if (op == "random") {
			a[i].black = rnd.next(0, d);
			a[i].white = d - a[i].black;
		}
		w ^= a[i].white;
	}
	assert(sumD == 0);
	if ((w & 1) != 0) {
		for (int i = 0; i < n; i++) {
			if (a[i].white != 0) {
				--a[i].white;
				++a[i].black;
				break;
			}
			if (a[i].black != 0) {
				--a[i].black;
				++a[i].white;
				break;
			}
		}
	}
	shuffle(a.begin(), a.end());
	return {a};
}

int main(int argc, char **argv) {
	registerGen(argc, argv, 1);
	int n = opt<int>("n");
	string type = opt<string>("type");
	vector<test> tests = { gen(n, type) };
	cout << tests.size() << '\n';
	for (auto &e : tests) {
		cout << e.a.size() << '\n';
		for (auto &v : e.a) {
			cout << v.white << ' ' << v.black << '\n';
		}
	}
}
